package de.hs_mannheim.informatik.bank.domain;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.Collection;
import java.util.HashMap;

public class Bank implements Serializable {
	private String name;
	private HashMap<Integer, Konto> konten = new HashMap<>();
	private HashMap<Integer, Kunde> kunden = new HashMap<>();
	private HashMap<Integer, Depot> depots = new HashMap<>();
	private int kontozähler;
	private int kundenzähler;
	
	public Bank(String name) {
		this.name = name;
		this.kontozähler = -1;
	}
	
	public int addKonto(Kunde kunde, int auswahl) {
		Konto k;
		Depot d;

		switch (auswahl) {
		case 1:
			k = new Konto(++kontozähler, kunde);
			konten.put(k.getKontonummer(), k);
			kunde.addKonto(k);
			return k.getKontonummer();
			//break;
		case 2:
			k = new Girokonto(++kontozähler, kunde);
			konten.put(k.getKontonummer(), k);
			kunde.addKonto(k);
			return k.getKontonummer();
			//break;
		case 3:
			d = new Depot(++kontozähler, kunde);
			depots.put(d.getKontonummer(), d);
			kunde.addDepot(d);
			return d.getKontonummer();
			//break;
		}
		/*if (auswahl == 1) 
			k = new Konto(++kontozähler, kunde);
		else 
			k = new Girokonto(++kontozähler, kunde);*/
		
		/*konten.put(k.getKontonummer(), k);
		kunde.addKonto(k);*/
		
		return -1;
	}
	
	public String getName() {
		return name;
	}
	
	public Collection<Konto> getKontenliste() {
		return konten.values();
	}
	public Collection<Kunde> getKundenliste() {
		return kunden.values();
	}
	public Collection<Depot> getDepotliste(){
		return depots.values();
	}


	public Konto findeKonto(int kontonummer) {
		return konten.get(kontonummer);
	}
	
	public int getKundenzähler() {
		return kundenzähler;
	}

	public int addKunde(String vorname, String nachname, String wohnort, int alter) {
		Kunde k = new Kunde(vorname, nachname,wohnort,alter,++kundenzähler);
		kunden.put(k.getKundennummer(), k);
		return k.getKundennummer();
		
	}

	public Kunde findeKunde(int kundennummer) {
		return kunden.get(kundennummer);
		
	}
	public Depot findeDepot(int kontonummer) {
		return depots.get(kontonummer);
	}
	

}
